---

 Microline/XmL/Folder.c  |   80 ++++++++++++++++++++++++++++++++++++++++--------
 Microline/XmL/FolderP.h |    3 +
 Microline/XmL/XmL.h     |    3 +
 source/window.c         |   34 ++++++++++++--------
 4 files changed, 93 insertions(+), 27 deletions(-)

diff --quilt old/Microline/XmL/Folder.c new/Microline/XmL/Folder.c
--- old/Microline/XmL/Folder.c
+++ new/Microline/XmL/Folder.c
@@ -325,6 +325,12 @@ static XtResource resources[] =
 		XtOffset(XmLFolderWidget, manager.shadow_thickness),
 		XmRImmediate, (XtPointer)2,
 		},
+		{
+		XmNnewTabCallback, XmCCallback,
+		XmRCallback, sizeof(XtCallbackList),
+		XtOffset(XmLFolderWidget, folder.newTabCallback),
+		XmRImmediate, (XtPointer)0,
+		},
     };
 
 static XtResource constraint_resources[] =
@@ -876,6 +882,7 @@ LayoutTopBottom(XmLFolderWidget f, 
   {
     int width, height, numTabs, y;
   } rows[MAX_TAB_ROWS];
+  unsigned int core_width = f->core.width;
 
   dpy = XtDisplay(f);
   children = f->composite.children;
@@ -904,6 +911,20 @@ LayoutTopBottom(XmLFolderWidget f, 
       int maxTabWidth = f->folder.maxTabWidth;
       int tabEffCount = 0;
 
+#if 0
+      if (f->folder.newTabWidget)
+	{
+	  int thisTabWidth;
+	  XtVaGetValues(f->folder.newTabWidget, XmNwidth, &thisTabWidth, NULL);
+	  thisTabWidth += (st + co + f->folder.marginWidth + ht +
+	      f->folder.newTabWidget->core.border_width) * 2;
+	  if (core_width > thisTabWidth)
+	    core_width -= thisTabWidth;
+	  fprintf(stderr, "%s: remove newTab space: %u %d\n",
+		  __func__, core_width, thisTabWidth);
+	}
+#endif
+
       for (i = 0; i < f->folder.tabCount; i++)
 	{
 	  tab = f->folder.tabs[i];
@@ -914,10 +935,11 @@ LayoutTopBottom(XmLFolderWidget f, 
 	
       tabPaddingWidth = (st + co + f->folder.marginWidth + ht +
 	      f->folder.tabs[0]->core.border_width) * 2;
-      if (maxTabWidth * tabEffCount > f->core.width)
+
+      if (maxTabWidth * tabEffCount > core_width)
         {
-      	  tgtTabWidth = f->core.width/tabEffCount - tabPaddingWidth;
-	  tailSpace = f->core.width % tabEffCount;
+      	  tgtTabWidth = core_width/tabEffCount - tabPaddingWidth;
+	  tailSpace = core_width % tabEffCount;
 	  tabFit = 1;
 	  
 	  /* if tabs get too small */
@@ -941,16 +963,19 @@ LayoutTopBottom(XmLFolderWidget f, 
 
       if (f->folder.resizePolicy == XmRESIZE_PACK)
         {
-	  if (tabFit)
-            {
-	      XtVaSetValues(tab, XmNwidth,
-      		      tailSpace? tgtTabWidth+1: tgtTabWidth, NULL);
-	      if (tailSpace)
-	      	 tailSpace--;
-            }
-	  else 
+	  if (tab != f->folder.newTabWidget)
 	    {
-	       XtVaSetValues(tab, XmNwidth, tgtTabWidth, NULL);
+	      if (tabFit)
+		{
+		  XtVaSetValues(tab, XmNwidth,
+			  tailSpace? tgtTabWidth+1: tgtTabWidth, NULL);
+		  if (tailSpace)
+		     tailSpace--;
+		}
+	      else
+		{
+		   XtVaSetValues(tab, XmNwidth, tgtTabWidth, NULL);
+		}
 	    }
 	}
       else
@@ -1178,7 +1203,7 @@ LayoutTopBottom(XmLFolderWidget f, 
       /* calculate tab padding */
       pad1 = 0;
       pad2 = 0;
-      w = f->core.width - rows[rowNum].width;
+      w = core_width - rows[rowNum].width;
       if (rowNum != f->folder.activeRow)
 	w -= 4;
       if (f->folder.tabsPerRow && w > 0)
@@ -1655,6 +1680,8 @@ ConstraintInitialize(Widget req, 
     fc->folder.managedName = (char *)strdup(fc->folder.managedName);
   if (XtIsSubclass(w, xmPrimitiveWidgetClass))
     {
+      Cardinal i, new_narg = 0;
+      Boolean isNewTabLabel = False;
       XtOverrideTranslations(w, f->folder.primTrans);
       XtAddCallback(w, XmNactivateCallback, PrimActivate, 0);
       XtVaSetValues(w,
@@ -1664,6 +1691,29 @@ ConstraintInitialize(Widget req, 
       if (XtIsSubclass(w, xmLabelWidgetClass))
 	XtVaSetValues(w, XmNfillOnArm, False, NULL);
 
+      for (i = 0; i < *narg; ++i)
+	{
+	  if (0 == strcmp(args[i].name, XmNisNewTabWidget))
+	    {
+	      isNewTabLabel = !!args[i].value;
+	    }
+	  else
+	    {
+	      args[new_narg].name  = args[i].name;
+	      args[new_narg].value = args[i].value;
+	      new_narg++;
+	    }
+	}
+      *narg = new_narg;
+
+      if (isNewTabLabel)
+	{
+#if 0
+	  fprintf(stderr, "%s: found new-tab label\n", __func__);
+#endif
+	  f->folder.newTabWidget = w;
+	}
+
       /* add child to tabs list */
       if (f->folder.tabAllocCount < f->folder.tabCount + 1)
 	{
@@ -1714,6 +1764,8 @@ ConstraintDestroy(Widget w)
     {
       XtRemoveCallback(w, XmNactivateCallback, PrimActivate, 0);
 
+      /* TODO: f->folder.newTabWidget == w */
+
       /* remove child from tabs list and calculate active pos */
       activePos = -1;
       j = 0;
@@ -3602,6 +3654,8 @@ PrimActivate(Widget w,
   XmLFolderWidget f;
   XmAnyCallbackStruct *cbs;
 
+  /* TODO: f->folder.newTabWidget == w */
+
   f = (XmLFolderWidget)XtParent(w);
   cbs = (XmAnyCallbackStruct *)callData;
   SetActiveTab(f, w, cbs->event, True);
diff --quilt old/Microline/XmL/FolderP.h new/Microline/XmL/FolderP.h
--- old/Microline/XmL/FolderP.h
+++ new/Microline/XmL/FolderP.h
@@ -85,6 +85,9 @@ typedef struct _XmLFolderPart
 
 	WidgetClass tabWidgetClass;
 
+	Widget newTabWidget;
+	XtCallbackList newTabCallback;
+
 	} XmLFolderPart;
 
 typedef struct _XmLFolderRec
diff --quilt old/Microline/XmL/XmL.h new/Microline/XmL/XmL.h
--- old/Microline/XmL/XmL.h
+++ new/Microline/XmL/XmL.h
@@ -117,6 +117,9 @@ extern "C" {
 #define XmNtabWidgetList "tabWidgetList"
 #define XmNtabWidgetClass "tabWidgetClass"
 #define XmCTabWidgetClass "TabWidgetClass"
+#define XmNisNewTabWidget "isNewTabWidget"
+#define XmCIsNewTabWidget "IsNewTabWidget"
+#define XmNnewTabCallback "newTabCallback"
 
 /* Folder Constraint resources */
 
diff --quilt old/source/window.c new/source/window.c
--- old/source/window.c
+++ new/source/window.c
@@ -602,7 +602,7 @@ WindowInfo *CreateWindow(const char *nam
     /* create the tab bar */
     window->tabBar = XtVaCreateManagedWidget("tabBar", 
        	    xmlFolderWidgetClass, tabForm,
-            XmNresizePolicy, XmRESIZE_DYNAMIC,
+            XmNresizePolicy, XmRESIZE_PACK,
 	    XmNleftAttachment, XmATTACH_FORM,
             XmNleftOffset, 0,
 	    XmNrightAttachment, XmATTACH_WIDGET,
@@ -845,25 +845,31 @@ static Widget addTab(Widget folder, cons
 {
     Widget tooltipLabel, tab;
     XmString s1, s2;
+    Arg args[16];
+    Cardinal nargs = 0;
 
     s1 = XmStringCreateSimple((char *)string);
     if (isNewTabTab)
         s2 = XmStringCreateSimple("New Document");
     else
         s2 = s1;
-    tab = XtVaCreateManagedWidget("tab",
-	    xrwsBubbleButtonWidgetClass, folder,
-	    /* XmNmarginWidth, <default@nedit.c>, */
-	    /* XmNmarginHeight, <default@nedit.c>, */
-  	    /* XmNalignment, <default@nedit.c>, */
-  	    XmNlabelString, s1,
-            XltNbubbleString, s2,
-	    XltNshowBubble, GetPrefToolTips(),
-	    XltNautoParkBubble, True,
-	    XltNslidingBubble, False,
-	    /* XltNdelay, 800,*/
-	    /* XltNbubbleDuration, 8000,*/
-	    NULL);
+
+/*     XtSetArg(args[nargs], XmNmarginWidth, <default@nedit.c>); nargs++; */
+/*     XtSetArg(args[nargs], XmNmarginHeight, <default@nedit.c>); nargs++; */
+/*     XtSetArg(args[nargs], XmNalignment, <default@nedit.c>); nargs++; */
+    XtSetArg(args[nargs], XmNlabelString, s1); nargs++;
+    XtSetArg(args[nargs], XltNbubbleString, s2); nargs++;
+    XtSetArg(args[nargs], XltNshowBubble, GetPrefToolTips()); nargs++;
+    XtSetArg(args[nargs], XltNautoParkBubble, True); nargs++;
+    XtSetArg(args[nargs], XltNslidingBubble, False); nargs++;
+/*     XtSetArg(args[nargs], XltNdelay, 800); nargs++; */
+/*     XtSetArg(args[nargs], XltNbubbleDuration, 8000); nargs++; */
+    if (isNewTabTab) {
+        XtSetArg(args[nargs], XmNisNewTabWidget, True); nargs++;
+    }
+
+    tab = XtCreateManagedWidget("tab", xrwsBubbleButtonWidgetClass, folder,
+            args, nargs);
     XmStringFree(s1);
     if (isNewTabTab)
         XmStringFree(s2);
